import { TypedEmitter, TypedEvents } from '@ztimson/utils';
import { Api } from './api';
export type AnalyticEvents = TypedEvents & {
    'IP_TRACE': (ip: string, trace: IpTrace) => any;
};
export type IpTrace = {
    "query": string;
    "status": string;
    "continent": string;
    "continentCode": string;
    "country": string;
    "countryCode": string;
    "region": string;
    "regionName": string;
    "city": string;
    "district": string;
    "zip": string;
    "lat": number;
    "lon": number;
    "timezone": string;
    "offset": number;
    "currency": string;
    "isp": string;
    "org": string;
    "as": string;
    "asname": string;
    "mobile": boolean;
    "proxy": boolean;
    "hosting": boolean;
    message?: string;
};
export declare class Analytics extends TypedEmitter<AnalyticEvents> {
    private readonly api;
    constructor(api: Api | string);
    traceIp(ip: string): import('@ztimson/utils').PromiseProgress<any>;
}
//# sourceMappingURL=analytics.d.ts.map