import { Api } from './api';
import { Meta } from './core';
import { TypedEmitter, TypedEvents } from '@ztimson/utils';
export type DataEvents = TypedEvents & {
    DELETE: (collection: string, document: string) => any;
    GET: (collection: string, documents: any) => any;
    RAW: (collection: string, response: any) => any;
    SET: (collection: string, document: any) => any;
};
export declare class Data extends TypedEmitter<DataEvents> {
    private readonly api;
    constructor(api: Api | string);
    delete(collection: string, document: string): Promise<void>;
    get<T extends Meta>(collection: string): Promise<T[]>;
    get<T extends Meta>(collection: string, document: string): Promise<T>;
    getSchema(): Promise<string[]>;
    raw<T>(collection: string, operand: string, query: any, options: any): Promise<T>;
    set<T extends Meta>(collection: string, document: Partial<T> & {
        _id?: string;
    }, append?: boolean): Promise<T>;
}
//# sourceMappingURL=data.d.ts.map