import { Actions } from './actions';
import { Ai } from './ai';
import { Analytics } from './analytics';
import { Api, ApiEvents } from './api';
import { Auth, AuthEvents, AuthOptions } from './auth';
import { Data, DataEvents } from './data';
import { Email, EmailEvents } from './email';
import { Groups } from './groups';
import { TypedEmitter, TypedEvents, HttpRequestOptions } from '@ztimson/utils';
import { Logger, LogLevel } from './logger';
import { Payments } from './payments';
import { Pdf, PdfEvents } from './pdf';
import { Socket } from './sockets';
import { Storage, StorageEvents } from './storage';
import { UI } from './ui';
import { Users } from './users';
import { Settings, SettingEvents } from './settings';
import { Static, StaticEvents } from './static';
export type MomentumEvents = TypedEvents & ApiEvents & AuthEvents & DataEvents & EmailEvents & PdfEvents & StaticEvents & StorageEvents & SettingEvents;
export type MomentumOptions = AuthOptions & {
    logLevel?: LogLevel;
    socket?: boolean;
    stripeSecret?: string;
    api?: HttpRequestOptions;
};
export declare class Momentum extends TypedEmitter<MomentumEvents> {
    api: Api;
    actions: Actions;
    ai: Ai;
    analytics: Analytics;
    auth: Auth;
    data: Data;
    email: Email;
    groups: Groups;
    logger: Logger;
    payments: Payments;
    pdf: Pdf;
    settings: Settings;
    socket?: Socket;
    static: Static;
    storage: Storage;
    ui: UI;
    users: Users;
    constructor(url?: string, opts?: MomentumOptions);
}
//# sourceMappingURL=momentum.d.ts.map