import { Api } from './api';
import { TypedEmitter, TypedEvents } from '@ztimson/utils';
import { BehaviorSubject } from 'rxjs';
/** Momentum variable */
export type Setting<T> = {
    /** Internal ID */
    _id?: string;
    /** Variable name */
    key: string;
    /** Variable value */
    value: T;
    /** Visible without authenticating */
    public?: boolean;
    /** Momentum variable, cannot be deleted */
    system?: boolean;
};
export type SettingEvents = TypedEvents & {
    LIST: (variables: {
        [key: string]: any;
    }) => any;
    DELETE: (key: string) => any;
    READ: (variable: Setting<any> | null) => any;
    UPDATE: (variable: Setting<any>) => any;
};
export declare class Settings extends TypedEmitter<SettingEvents> {
    readonly api: Api;
    $cache: BehaviorSubject<{
        [key: string]: any;
    }>;
    get cache(): {
        [key: string]: any;
    };
    set cache(val: {
        [key: string]: any;
    });
    constructor(api: Api | string);
    list(detailed?: boolean): Promise<{
        [key: string]: any;
    }>;
    delete(key: string): Promise<void>;
    read(key: string, reload?: boolean): Promise<Setting<any> | null>;
    update(variable: Setting<any>): Promise<Setting<any>>;
}
//# sourceMappingURL=settings.d.ts.map