import { Api } from './api';
import { TypedEmitter, TypedEvents } from '@ztimson/utils';
import { FileMeta } from './storage';
export type StaticEvents = TypedEvents & {
    LIST: (path: string, response: string[] | FileMeta) => any;
    DELETE: (path: string) => any;
    UPLOAD: (files: string[]) => any;
};
export declare class Static extends TypedEmitter<StaticEvents> {
    private readonly api;
    constructor(api: Api | string);
    delete(path: string): Promise<void>;
    list(path: string): Promise<string[] | FileMeta>;
    upload(files: File | File[], path?: string): Promise<string[]>;
}
//# sourceMappingURL=static.d.ts.map